// FullAccess
resource "azurerm_role_definition" "media_services_fullaccess_definition" {
  name              = "media-services-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Media/register/action",
      "Microsoft.Media/unregister/action",
      "Microsoft.Media/checknameavailability/action",
      "Microsoft.Media/operations/read",
      "Microsoft.Media/mediaservices/read",
      "Microsoft.Media/mediaservices/write",
      "Microsoft.Media/mediaservices/delete",
      "Microsoft.Media/mediaservices/syncStorageKeys/action",
      "Microsoft.Media/mediaservices/assets/read",
      "Microsoft.Media/mediaservices/assets/write",
      "Microsoft.Media/mediaservices/assets/delete",
      "Microsoft.Media/mediaservices/assets/listContainerSas/action",
      "Microsoft.Media/mediaservices/assets/getEncryptionKey/action",
      "Microsoft.Media/mediaservices/assets/listStreamingLocators/action",
      "Microsoft.Media/mediaservices/streamingPolicies/read",
      "Microsoft.Media/mediaservices/streamingPolicies/write",
      "Microsoft.Media/mediaservices/streamingPolicies/delete",
      "Microsoft.Media/mediaservices/streamingLocators/read",
      "Microsoft.Media/mediaservices/streamingLocators/write",
      "Microsoft.Media/mediaservices/streamingLocators/delete",
      "Microsoft.Media/mediaservices/streamingLocators/listContentKeys/action",
      "Microsoft.Media/mediaservices/streamingLocators/listPaths/action",
      "Microsoft.Media/mediaservices/contentKeyPolicies/read",
      "Microsoft.Media/mediaservices/contentKeyPolicies/write",
      "Microsoft.Media/mediaservices/contentKeyPolicies/delete",
      "Microsoft.Media/mediaservices/contentKeyPolicies/getPolicyPropertiesWithSecrets/action",
      "Microsoft.Media/mediaservices/transforms/read",
      "Microsoft.Media/mediaservices/transforms/write",
      "Microsoft.Media/mediaservices/transforms/delete",
      "Microsoft.Media/mediaservices/transforms/jobs/read",
      "Microsoft.Media/mediaservices/transforms/jobs/write",
      "Microsoft.Media/mediaservices/transforms/jobs/delete",
      "Microsoft.Media/mediaservices/transforms/jobs/cancelJob/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/read",
      "Microsoft.Media/mediaservices/streamingEndpoints/write",
      "Microsoft.Media/mediaservices/streamingEndpoints/delete",
      "Microsoft.Media/mediaservices/streamingEndpoints/start/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/stop/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/scale/action",
      "Microsoft.Media/mediaservices/liveEvents/read",
      "Microsoft.Media/mediaservices/liveEvents/write",
      "Microsoft.Media/mediaservices/liveEvents/delete",
      "Microsoft.Media/mediaservices/liveEvents/start/action",
      "Microsoft.Media/mediaservices/liveEvents/stop/action",
      "Microsoft.Media/mediaservices/liveEvents/reset/action",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/read",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/write",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/delete",
      "Microsoft.Media/mediaservices/streamingEndpointOperations/read",
      "Microsoft.Media/mediaservices/liveEventOperations/read",
      "Microsoft.Media/mediaservices/liveOutputOperations/read",
      "Microsoft.Media/locations/checkNameAvailability/action",
      "Microsoft.Media/mediaservices/eventGridFilters/read",
      "Microsoft.Media/mediaservices/eventGridFilters/write",
      "Microsoft.Media/mediaservices/eventGridFilters/delete",
      "Microsoft.Media/mediaservices/accountfilters/read",
      "Microsoft.Media/mediaservices/accountfilters/write",
      "Microsoft.Media/mediaservices/accountfilters/delete",
      "Microsoft.Media/mediaservices/assets/assetfilters/read",
      "Microsoft.Media/mediaservices/assets/assetfilters/write",
      "Microsoft.Media/mediaservices/assets/assetfilters/delete",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "media_services_readonly_definition" {
  name              = "media-services-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Media/operations/read",
      "Microsoft.Media/mediaservices/read",
      "Microsoft.Media/mediaservices/assets/read",
      "Microsoft.Media/mediaservices/streamingPolicies/read",
      "Microsoft.Media/mediaservices/streamingLocators/read",
      "Microsoft.Media/mediaservices/contentKeyPolicies/read",
      "Microsoft.Media/mediaservices/transforms/read",
      "Microsoft.Media/mediaservices/transforms/jobs/read",
      "Microsoft.Media/mediaservices/streamingEndpoints/read",
      "Microsoft.Media/mediaservices/liveEvents/read",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/read",
      "Microsoft.Media/mediaservices/streamingEndpointOperations/read",
      "Microsoft.Media/mediaservices/liveEventOperations/read",
      "Microsoft.Media/mediaservices/liveOutputOperations/read",
      "Microsoft.Media/mediaservices/eventGridFilters/read",
      "Microsoft.Media/mediaservices/accountfilters/read",
      "Microsoft.Media/mediaservices/assets/assetfilters/read",
    ]

    not_actions = [
      "Microsoft.Media/register/action",
      "Microsoft.Media/unregister/action",
      "Microsoft.Media/checknameavailability/action",
      "Microsoft.Media/mediaservices/write",
      "Microsoft.Media/mediaservices/delete",
      "Microsoft.Media/mediaservices/syncStorageKeys/action",
      "Microsoft.Media/mediaservices/assets/write",
      "Microsoft.Media/mediaservices/assets/delete",
      "Microsoft.Media/mediaservices/assets/listContainerSas/action",
      "Microsoft.Media/mediaservices/assets/getEncryptionKey/action",
      "Microsoft.Media/mediaservices/assets/listStreamingLocators/action",
      "Microsoft.Media/mediaservices/streamingPolicies/write",
      "Microsoft.Media/mediaservices/streamingPolicies/delete",
      "Microsoft.Media/mediaservices/streamingLocators/write",
      "Microsoft.Media/mediaservices/streamingLocators/delete",
      "Microsoft.Media/mediaservices/streamingLocators/listContentKeys/action",
      "Microsoft.Media/mediaservices/streamingLocators/listPaths/action",
      "Microsoft.Media/mediaservices/contentKeyPolicies/write",
      "Microsoft.Media/mediaservices/contentKeyPolicies/delete",
      "Microsoft.Media/mediaservices/contentKeyPolicies/getPolicyPropertiesWithSecrets/action",
      "Microsoft.Media/mediaservices/transforms/write",
      "Microsoft.Media/mediaservices/transforms/delete",
      "Microsoft.Media/mediaservices/transforms/jobs/write",
      "Microsoft.Media/mediaservices/transforms/jobs/delete",
      "Microsoft.Media/mediaservices/transforms/jobs/cancelJob/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/write",
      "Microsoft.Media/mediaservices/streamingEndpoints/delete",
      "Microsoft.Media/mediaservices/streamingEndpoints/start/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/stop/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/scale/action",
      "Microsoft.Media/mediaservices/liveEvents/write",
      "Microsoft.Media/mediaservices/liveEvents/delete",
      "Microsoft.Media/mediaservices/liveEvents/start/action",
      "Microsoft.Media/mediaservices/liveEvents/stop/action",
      "Microsoft.Media/mediaservices/liveEvents/reset/action",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/write",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/delete",
      "Microsoft.Media/locations/checkNameAvailability/action",
      "Microsoft.Media/mediaservices/eventGridFilters/write",
      "Microsoft.Media/mediaservices/eventGridFilters/delete",
      "Microsoft.Media/mediaservices/accountfilters/write",
      "Microsoft.Media/mediaservices/accountfilters/delete",
      "Microsoft.Media/mediaservices/assets/assetfilters/write",
      "Microsoft.Media/mediaservices/assets/assetfilters/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "media_services_noaccess_definition" {
  name              = "media-services-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.Media/register/action",
      "Microsoft.Media/unregister/action",
      "Microsoft.Media/checknameavailability/action",
      "Microsoft.Media/operations/read",
      "Microsoft.Media/mediaservices/read",
      "Microsoft.Media/mediaservices/write",
      "Microsoft.Media/mediaservices/delete",
      "Microsoft.Media/mediaservices/syncStorageKeys/action",
      "Microsoft.Media/mediaservices/assets/read",
      "Microsoft.Media/mediaservices/assets/write",
      "Microsoft.Media/mediaservices/assets/delete",
      "Microsoft.Media/mediaservices/assets/listContainerSas/action",
      "Microsoft.Media/mediaservices/assets/getEncryptionKey/action",
      "Microsoft.Media/mediaservices/assets/listStreamingLocators/action",
      "Microsoft.Media/mediaservices/streamingPolicies/read",
      "Microsoft.Media/mediaservices/streamingPolicies/write",
      "Microsoft.Media/mediaservices/streamingPolicies/delete",
      "Microsoft.Media/mediaservices/streamingLocators/read",
      "Microsoft.Media/mediaservices/streamingLocators/write",
      "Microsoft.Media/mediaservices/streamingLocators/delete",
      "Microsoft.Media/mediaservices/streamingLocators/listContentKeys/action",
      "Microsoft.Media/mediaservices/streamingLocators/listPaths/action",
      "Microsoft.Media/mediaservices/contentKeyPolicies/read",
      "Microsoft.Media/mediaservices/contentKeyPolicies/write",
      "Microsoft.Media/mediaservices/contentKeyPolicies/delete",
      "Microsoft.Media/mediaservices/contentKeyPolicies/getPolicyPropertiesWithSecrets/action",
      "Microsoft.Media/mediaservices/transforms/read",
      "Microsoft.Media/mediaservices/transforms/write",
      "Microsoft.Media/mediaservices/transforms/delete",
      "Microsoft.Media/mediaservices/transforms/jobs/read",
      "Microsoft.Media/mediaservices/transforms/jobs/write",
      "Microsoft.Media/mediaservices/transforms/jobs/delete",
      "Microsoft.Media/mediaservices/transforms/jobs/cancelJob/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/read",
      "Microsoft.Media/mediaservices/streamingEndpoints/write",
      "Microsoft.Media/mediaservices/streamingEndpoints/delete",
      "Microsoft.Media/mediaservices/streamingEndpoints/start/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/stop/action",
      "Microsoft.Media/mediaservices/streamingEndpoints/scale/action",
      "Microsoft.Media/mediaservices/liveEvents/read",
      "Microsoft.Media/mediaservices/liveEvents/write",
      "Microsoft.Media/mediaservices/liveEvents/delete",
      "Microsoft.Media/mediaservices/liveEvents/start/action",
      "Microsoft.Media/mediaservices/liveEvents/stop/action",
      "Microsoft.Media/mediaservices/liveEvents/reset/action",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/read",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/write",
      "Microsoft.Media/mediaservices/liveEvents/liveOutputs/delete",
      "Microsoft.Media/mediaservices/streamingEndpointOperations/read",
      "Microsoft.Media/mediaservices/liveEventOperations/read",
      "Microsoft.Media/mediaservices/liveOutputOperations/read",
      "Microsoft.Media/locations/checkNameAvailability/action",
      "Microsoft.Media/mediaservices/eventGridFilters/read",
      "Microsoft.Media/mediaservices/eventGridFilters/write",
      "Microsoft.Media/mediaservices/eventGridFilters/delete",
      "Microsoft.Media/mediaservices/accountfilters/read",
      "Microsoft.Media/mediaservices/accountfilters/write",
      "Microsoft.Media/mediaservices/accountfilters/delete",
      "Microsoft.Media/mediaservices/assets/assetfilters/read",
      "Microsoft.Media/mediaservices/assets/assetfilters/write",
      "Microsoft.Media/mediaservices/assets/assetfilters/delete",
    ]
  }
}
